# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_saas.models.resourcecontrollerk8v3_text_content import Resourcecontrollerk8v3TextContent
from typing import Optional, Set
from typing_extensions import Self

class Resourcecontrollerk8v3AppFile(BaseModel):
    """
    AppFile contains the information about an app file.
    """ # noqa: E501
    app_id: Optional[StrictStr] = Field(default=None, description="Optional: The internal ID of the app for the file.")
    content: Optional[StrictStr] = Field(default=None, description="The text content of the app file.")
    created: Optional[StrictStr] = Field(default=None, description="Optional: The date this app file was created (ms since epoch).")
    description: Optional[Resourcecontrollerk8v3TextContent] = None
    id: Optional[StrictStr] = Field(default=None, description="Optional: The internal ID of the app file.")
    mime_type: Optional[StrictStr] = Field(default=None, description="The mime type of the app file (only used to provide an editor).")
    modified: Optional[StrictStr] = Field(default=None, description="Optional: The date this app file was modified (ms since epoch).")
    name: Optional[StrictStr] = Field(default=None, description="The name of the app file.")
    path: Optional[StrictStr] = Field(default=None, description="The path to the file for the app.")
    restart_app: Optional[StrictBool] = Field(default=None, description="True if the app should be restarted when updating this file, false otherwise.")
    __properties: ClassVar[List[str]] = ["app_id", "content", "created", "description", "id", "mime_type", "modified", "name", "path", "restart_app"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Resourcecontrollerk8v3AppFile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of description
        if self.description:
            _dict['description'] = self.description.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Resourcecontrollerk8v3AppFile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "app_id": obj.get("app_id"),
            "content": obj.get("content"),
            "created": obj.get("created"),
            "description": Resourcecontrollerk8v3TextContent.from_dict(obj["description"]) if obj.get("description") is not None else None,
            "id": obj.get("id"),
            "mime_type": obj.get("mime_type"),
            "modified": obj.get("modified"),
            "name": obj.get("name"),
            "path": obj.get("path"),
            "restart_app": obj.get("restart_app")
        })
        return _obj


