# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Resourcecontrollerk8v3ControllerCommand(BaseModel):
    """
    Contains the command information to be executed by a controller.
    """ # noqa: E501
    args: Optional[Dict[str, Any]] = Field(default=None, description="The command arguments.")
    created: Optional[StrictStr] = Field(default=None, description="The date this command was created (ms since epoch).")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the command.")
    modified: Optional[StrictStr] = Field(default=None, description="The date this command was modified (ms since epoch).")
    result: Optional[StrictStr] = Field(default=None, description="The result of the command. This value is write-only and can only be written once.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the command. The current valid values are pending, success, error.")
    type: Optional[StrictStr] = Field(default=None, description="The type of command. The current valid values are get_app_logs.")
    __properties: ClassVar[List[str]] = ["args", "created", "id", "modified", "result", "status", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Resourcecontrollerk8v3ControllerCommand from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Resourcecontrollerk8v3ControllerCommand from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "args": obj.get("args"),
            "created": obj.get("created"),
            "id": obj.get("id"),
            "modified": obj.get("modified"),
            "result": obj.get("result"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


