# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_saas.models.riskanalyticscontrollerv3_observation_report_filter import Riskanalyticscontrollerv3ObservationReportFilter
from ibm_gdsc_sdk_saas.models.riskanalyticscontrollerv3_statistics import Riskanalyticscontrollerv3Statistics
from typing import Optional, Set
from typing_extensions import Self

class Riskanalyticscontrollerv3FindingReferenceLink(BaseModel):
    """
    [risk-details] A reference link within a finding; used for representing a deep-link to relevant report.
    """ # noqa: E501
    report_filters: Optional[List[Riskanalyticscontrollerv3ObservationReportFilter]] = None
    statistics: Optional[Riskanalyticscontrollerv3Statistics] = None
    text: Optional[StrictStr] = Field(default=None, description="Final text, generated from text_template (localized) and text_variables (as-is).")
    text_template: Optional[StrictStr] = Field(default=None, description="Text template key in insights-nls project; used to create the final text for the UI, during the response.")
    text_variables: Optional[List[StrictStr]] = Field(default=None, description="[optional] Variable text tokens that replace placeholders in the text template; ordered according to appearance in template.")
    __properties: ClassVar[List[str]] = ["report_filters", "statistics", "text", "text_template", "text_variables"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3FindingReferenceLink from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in report_filters (list)
        _items = []
        if self.report_filters:
            for _item in self.report_filters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['report_filters'] = _items
        # override the default output from pydantic by calling `to_dict()` of statistics
        if self.statistics:
            _dict['statistics'] = self.statistics.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Riskanalyticscontrollerv3FindingReferenceLink from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "report_filters": [Riskanalyticscontrollerv3ObservationReportFilter.from_dict(_item) for _item in obj["report_filters"]] if obj.get("report_filters") is not None else None,
            "statistics": Riskanalyticscontrollerv3Statistics.from_dict(obj["statistics"]) if obj.get("statistics") is not None else None,
            "text": obj.get("text"),
            "text_template": obj.get("text_template"),
            "text_variables": obj.get("text_variables")
        })
        return _obj


