# coding: utf-8

"""
    IBM Guardium Data Security Center

    Use Guardium Data Security Center SDK (application programming interfaces) to interact with other applications, such as Guardium Data Protection, universal connectors, and Guardium Data Security Center reports.

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ibm_gdsc_sdk_saas.models.workflowv3_entity_header_type import Workflowv3EntityHeaderType
from ibm_gdsc_sdk_saas.models.workflowv3_entity_value_choice import Workflowv3EntityValueChoice
from typing import Optional, Set
from typing_extensions import Self

class Workflowv3EntityHeader(BaseModel):
    """
    Workflowv3EntityHeader
    """ # noqa: E501
    choices: Optional[List[Workflowv3EntityValueChoice]] = None
    group_type_id: Optional[StrictInt] = None
    hide_from_view: Optional[StrictBool] = None
    key: Optional[StrictStr] = None
    type: Optional[Workflowv3EntityHeaderType] = None
    value: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["choices", "group_type_id", "hide_from_view", "key", "type", "value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Workflowv3EntityHeader from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in choices (list)
        _items = []
        if self.choices:
            for _item in self.choices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['choices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Workflowv3EntityHeader from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "choices": [Workflowv3EntityValueChoice.from_dict(_item) for _item in obj["choices"]] if obj.get("choices") is not None else None,
            "group_type_id": obj.get("group_type_id"),
            "hide_from_view": obj.get("hide_from_view"),
            "key": obj.get("key"),
            "type": obj.get("type"),
            "value": obj.get("value")
        })
        return _obj


